/***************************************************************************
 R. Leblois 2001-2004
 F. Rousset 2005-2008

rousset@isem.univ-montp2.fr

This file is part of IBDSim. This software is a computer program
whose purpose is to perform population genetic simulations.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

 ***************************************************************************/
#include <cmath> // rajout pour Dev-C++ ...
#include <iostream>
#include <iomanip>
#include <string>
#include <ctime>
#include <cstdlib>
#include <list>
#include <map>
#include <fstream>
#include <sstream>
#include <cctype>
#include <cstdio>
#include "genepop_extract.h"

using namespace std;

#ifdef WIN32
#include <windows.h>
void _gotoxy(int x,int y) {
    COORD mescoord;
    mescoord.X=x;
    mescoord.Y=y;
    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),mescoord);
}/**/
void effacer_ecran() {
    system("cls");
}
#else //vt100 terminals
void _gotoxy(int x,int y) {
//    printf("\033[%d;%dH",y+1,x+1);
      cout<<"\033["<<y+1<<";"<<x+1<<"H"<<flush; //equiv printf+flush ?
}
void effacer_ecran() {
//    system("clear"); //hum
//    printf("\033[2J");
      cout<<"\033[2J"<<flush; //equiv printf+flush ?
      _gotoxy(0,0);
}
#endif

using namespace std;

// utilitaire de comparaison de chaines insensible  la casse
//attention sortie non intuitive! voir des usages precdents
int cmp_nocase(const string& s, const string& s2) {
	string::const_iterator p = s.begin();
	string::const_iterator p2 = s2.begin();

	while(p != s.end() && p2 != s2.end()) {
		if (toupper(*p) != toupper(*p2)) return((toupper(*p)<toupper(*p2)) ? -1 : 1);
		++p; ++p2;
	}
	return((s2.size()==s.size()) ? 0 : (s2.size()<s.size()) ? -1 : 1);
}
// vire les blancs  droite
void rtrim(string *s) {
	while ((s->length()>0)  && (s->substr(s->length()-1,1)) == " ") {
			s->erase(s->length()-1,s->length());
	}
}



